Index: /branches/prototype-v0/zoo-project/zoo-kernel/ulinet.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/ulinet.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/ulinet.c	(revision 854)
@@ -211,6 +211,53 @@
   ret.agent=strdup(lpszAgent);
   ret.nb=0;
+  ret.waitingRequests[ret.nb] = NULL;
   ret.ihandle[ret.nb].header=NULL;
+  ret.ihandle[ret.nb].handle=NULL;
+  ret.ihandle[ret.nb].hasCacheFile=0;
+  ret.ihandle[ret.nb].nDataAlloc = 0;
+  ret.ihandle[ret.nb].url = NULL;
+  ret.ihandle[ret.nb].mimeType = NULL;
+  ret.ihandle[ret.nb].cookie = NULL;
+  ret.ihandle[ret.nb].nDataLen = 0;
+  ret.ihandle[ret.nb].nDataAlloc = 0;
+  ret.ihandle[ret.nb].pabyData = NULL;
+  ret.ihandle[ret.nb].post = NULL;
   return ret;
+}
+
+/**
+ * Verify if the URL should use a shared cache or not.
+ *
+ * In case the security section contains a key named "shared", then if the
+ * domain listed in the shared key are contained in the url given as parameter
+ * then it return "SHARED" in other cases, it returns "OTHER".
+ *
+ * @param conf the main configuration file maps
+ * @param url the URL to evaluate
+ * @return a string "SHARED" in case the host is in a domain listed in the
+ * shared key, "OTHER" in other cases.
+ */
+char* getProvenance(maps* conf,const char* url){
+  map* sharedCache=getMapFromMaps(conf,"security","shared");
+  if(sharedCache!=NULL){
+    char *res=NULL;
+    char *hosts=sharedCache->value;
+    char *curs=strtok(hosts,",");
+    while(curs!=NULL){
+      fprintf(stderr,"### %s %d %s \n",__FILE__,__LINE__,strstr(url,curs));
+      fflush(stderr);
+      if(strstr(url,curs)==NULL)
+	res="OTHER";
+      else{
+	res="SHARED";
+	fprintf(stderr,"### %s %d %s \n",__FILE__,__LINE__,"SHARED");
+	fflush(stderr);
+	return res;
+      }
+      curs=strtok(NULL,",");
+    }
+    return res;
+  }
+  return "OTHER";
 }
 
@@ -282,5 +329,5 @@
     int i;
     for(i=0;i<handle->nb;i++){
-      if(targetHosts->value[0]=='*' || isProtectedHost(targetHosts->value,handle->ihandle[i].url)==1){
+      if(strstr(targetHosts->value,"*")!=NULL || isProtectedHost(targetHosts->value,handle->ihandle[i].url)==1){
 	while (token != NULL){
 	  int length=strlen(token)+6;
@@ -297,8 +344,10 @@
 	  }
 	  fprintf(stderr,"%s %d %s \n",__FILE__,__LINE__,tmp1);
-	  if(strncmp(tmp1,"HTTP_COOKIE",11)!=0){	    
-	    tmpMap = getMapFromMaps(conf,"renv",tmp1);
-	    if(tmpMap!=NULL)
-	      AddMissingHeaderEntry(&handle->ihandle[i],token,tmpMap->value);
+	  //dumpMaps(conf);
+	  tmpMap = getMapFromMaps(conf,"renv",tmp1);
+	  if(tmpMap!=NULL){
+	    fprintf(stderr,"add header %s %s\n",token,tmpMap->value);
+	    fflush(stderr);
+	    AddMissingHeaderEntry(&handle->ihandle[i],token,tmpMap->value);
 	  }
 	  free(tmp1);
@@ -321,42 +370,46 @@
 void InternetCloseHandle(HINTERNET* handle0){
   int i=0;
-  for(i=0;i<handle0->nb;i++){
-    _HINTERNET handle=handle0->ihandle[i];
-    if(handle.hasCacheFile>0){
-      fclose(handle.file);
-      unlink(handle.filename);
-    }
-    else{
-      handle.pabyData = NULL;
-      handle.nDataAlloc = handle.nDataLen = 0;
-    }
-    if(handle0->ihandle[i].header!=NULL){
-      curl_slist_free_all(handle0->ihandle[i].header);
-      handle0->ihandle[i].header=NULL;
-    }
-    if(handle.post!=NULL)
-      free(handle.post);
-    if(handle.url!=NULL)
-      free(handle.url);
-    if(handle.mimeType!=NULL)
-      free(handle.mimeType);
-    if(handle.cookie!=NULL)
-      free(handle.cookie);
-  }
-  fprintf(stderr,"%s%d\n",__FILE__,__LINE__);
-  fflush(stderr);
-  if(handle0->handle)
-    curl_multi_cleanup(handle0->handle);
-  fprintf(stderr,"%s%d\n",__FILE__,__LINE__);
-  fflush(stderr);
-  free(handle0->agent);
-  fprintf(stderr,"%s%d\n",__FILE__,__LINE__);
-  fflush(stderr);
-  for(i=handle0->nb-1;i>=0;i--){
-    fprintf(stderr,"%s%d\n",__FILE__,__LINE__);
-    fflush(stderr);
-    free(handle0->waitingRequests[i]);
-      fprintf(stderr,"%s%d\n",__FILE__,__LINE__);
-      fflush(stderr);
+  if(handle0!=NULL){
+    for(i=0;i<handle0->nb;i++){
+      _HINTERNET handle=handle0->ihandle[i];
+      if(handle.hasCacheFile>0){
+	fclose(handle.file);
+	unlink(handle.filename);
+      }
+      else{
+	handle.pabyData = NULL;
+	handle.nDataAlloc = handle.nDataLen = 0;
+      }
+      if(handle.header!=NULL){
+	curl_slist_free_all(handle.header);
+	handle.header=NULL;
+      }
+      if(handle.post!=NULL){
+	free(handle.post);
+	handle.post=NULL;
+      }
+      if(handle.url!=NULL){
+	free(handle.url);
+	handle.url=NULL;
+      }
+      if(handle.mimeType!=NULL){
+	free(handle.mimeType);
+	handle.mimeType=NULL;
+      }
+      if(handle.cookie!=NULL){
+	free(handle.cookie);
+	handle.cookie=NULL;
+      }
+      if(handle0->waitingRequests[i]!=NULL){
+	free(handle0->waitingRequests[i]);
+	handle0->waitingRequests[i]=NULL;
+      }
+    }
+    if(handle0->handle)
+      curl_multi_cleanup(handle0->handle);
+    if(handle0->agent!=NULL){
+      free(handle0->agent);
+      handle0->agent=NULL;
+    }
   }
 }
@@ -377,24 +430,56 @@
   struct MemoryStruct header;
 
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].handle=curl_easy_init( );
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].hasCacheFile=0;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].nDataAlloc = 0;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].url = NULL;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].mimeType = NULL;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].cookie = NULL;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].nDataLen = 0;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].id = hInternet->nb;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].nDataAlloc = 0;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].pabyData = NULL;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   hInternet->ihandle[hInternet->nb].post = NULL;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   
   curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle, CURLOPT_COOKIEFILE, "ALL");
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
 #ifndef TIGER
   curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle, CURLOPT_COOKIELIST, "ALL");
 #endif
   curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle, CURLOPT_USERAGENT, hInternet->agent);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   
   curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle,CURLOPT_FOLLOWLOCATION,1);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle,CURLOPT_MAXREDIRS,3);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   
   header.memory=NULL;
@@ -402,5 +487,9 @@
 
   curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle, CURLOPT_HEADERFUNCTION, header_write_data);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle, CURLOPT_WRITEHEADER, (void *)&header);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
 
 #ifdef MSG_LAF_VERBOSE
@@ -431,4 +520,6 @@
       break;
     }
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
 #ifdef ULINET_DEBUG
   fprintf(stderr,"URL (%s)\nBODY (%s)\n",lpszUrl,lpszHeaders);
@@ -448,14 +539,25 @@
     curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle,CURLOPT_POSTFIELDSIZE,(long)dwHeadersLength);
   }
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   if(hInternet->ihandle[hInternet->nb].header!=NULL)
     curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle,CURLOPT_HTTPHEADER,hInternet->ihandle[hInternet->nb].header);
 
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   curl_easy_setopt(hInternet->ihandle[hInternet->nb].handle,CURLOPT_URL,lpszUrl);
   hInternet->ihandle[hInternet->nb].url = zStrdup(lpszUrl);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
 
   curl_multi_add_handle(hInternet->handle,hInternet->ihandle[hInternet->nb].handle);
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   
   hInternet->ihandle[hInternet->nb].header=NULL;
+  fprintf(stderr,"%s %d\n",__FILE__,__LINE__);
+  fflush(stderr);
   ++hInternet->nb;
+  hInternet->ihandle[hInternet->nb].header=NULL;
 
 #ifdef ULINET_DEBUG
@@ -481,10 +583,16 @@
   for(i=0;i<hInternet->nb;i++){
     char *tmp;
+    fprintf(stderr," *** %s %d %d \n",__FILE__,__LINE__,i);
     curl_easy_getinfo(hInternet->ihandle[i].handle,CURLINFO_CONTENT_TYPE,&tmp);
+    fprintf(stderr," *** %s %d %d \n",__FILE__,__LINE__,i);
     if(tmp!=NULL)
       hInternet->ihandle[i].mimeType=strdup(tmp);
+    fprintf(stderr," *** %s %d %d \n",__FILE__,__LINE__,i);
     curl_easy_getinfo(hInternet->ihandle[i].handle,CURLINFO_RESPONSE_CODE,&hInternet->ihandle[i].code);
+    fprintf(stderr," *** %s %d %d \n",__FILE__,__LINE__,i);
     curl_multi_remove_handle(hInternet->handle, hInternet->ihandle[i].handle);
+    fprintf(stderr," *** %s %d %d \n",__FILE__,__LINE__,i);
     curl_easy_cleanup(hInternet->ihandle[i].handle);
+    fprintf(stderr," *** %s %d %d \n",__FILE__,__LINE__,i);
     //fprintf(stderr,"%s %d %s \n",__FILE__,__LINE__,hInternet->ihandle[i].mimeType);
     //fprintf(stderr,"%s %d %s \n",__FILE__,__LINE__,hInternet->ihandle[i].pabyData);
Index: /branches/prototype-v0/zoo-project/zoo-kernel/ulinet.h
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/ulinet.h	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/ulinet.h	(revision 854)
@@ -128,4 +128,5 @@
   HINTERNET InternetOpen(char*,int,char*,char*,int);
 
+  char* getProvenance(maps*,const char*);
   int isProtectedHost(const char*,const char*);
   int AddMissingHeaderEntry(_HINTERNET*,const char*,const char*);
Index: /branches/prototype-v0/zoo-project/zoo-kernel/zoo_loader.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/zoo_loader.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/zoo_loader.c	(revision 854)
@@ -86,4 +86,10 @@
   fflush(stderr);
 #endif
+  fprintf (stderr, "Addr:%s\n", cgiRemoteAddr); 
+  fprintf (stderr, "RequestMethod: (%s) %d %d\n", cgiRequestMethod,strncasecmp(cgiRequestMethod,"post",4),strncmp(cgiContentType,"text/xml",8)==0 || strncasecmp(cgiRequestMethod,"post",4)==0); 
+  fprintf (stderr, "Request: %s\n", cgiQueryString);
+  fprintf (stderr, "ContentType: %s\n", cgiContentType);
+  fprintf (stderr, "ContentLength: %d\n", cgiContentLength);
+  fflush(stderr);
   
   char *strQuery=NULL;
Index: /branches/prototype-v0/zoo-project/zoo-kernel/zoo_service_loader.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-kernel/zoo_service_loader.c	(revision 854)
@@ -107,4 +107,5 @@
 #include <dirent.h>
 #include <signal.h>
+#include <execinfo.h>
 #include <unistd.h>
 #ifndef WIN32
@@ -122,4 +123,14 @@
 #include <time.h>
 #include <stdarg.h>
+
+#include <libxml/tree.h>
+#include <libxml/parser.h>
+#include <libxml/xpath.h>
+#include <libxml/xpathInternals.h>
+
+#include <libxslt/xslt.h>
+#include <libxslt/xsltInternals.h>
+#include <libxslt/transform.h>
+#include <libxslt/xsltutils.h>
 
 #ifndef WIN32
@@ -385,4 +396,5 @@
 sig_handler (int sig)
 {
+  
   char tmp[100];
   const char *ssig;
@@ -413,5 +425,5 @@
   sprintf (tmp,
            _
-           ("ZOO Kernel failed to process your request, receiving signal %d = %s"),
+           ("ZOO Kernel failed to process your request, receiving signal %d = %s "),
            sig, ssig);
   errorException (NULL, tmp, "InternalError", NULL);
@@ -990,7 +1002,7 @@
 #ifdef ETC_DIR
 #ifndef WIN32
-    getcwd (ntmp, 1024);
+  getcwd (ntmp, 1024);
 #else
-    _getcwd (ntmp, 1024);
+  _getcwd (ntmp, 1024);
 #endif
 #endif
@@ -1184,5 +1196,5 @@
   fprintf(stderr," ** DEBUG %s %d \n",__FILE__,__LINE__);
   fflush(stderr);
-  dumpMap(r_inputs);
+  //dumpMap(r_inputs);
   fprintf(stderr," ** DEBUG %s %d \n",__FILE__,__LINE__);
   fflush(stderr);
@@ -1294,4 +1306,6 @@
   }
 
+  dumpMap(request_inputs);
+
   if (strncasecmp (REQUEST, "GetCapabilities", 15) == 0)
     {
@@ -1348,5 +1362,4 @@
 #ifdef META_DB
       fetchServicesFromDb(zooRegistry,m,doc,n,printGetCapabilitiesForProcess,1);
-      fprintf(stderr,"************************* %s %d\n\n",__FILE__,__LINE__);
       close_sql(m,0);
 #endif      
@@ -1430,4 +1443,6 @@
 	    r_inputs = NULL;
 	    r_inputs = getMap (request_inputs, "version");
+	    fprintf(stderr," ** DEBUG %s %d \n",__FILE__,__LINE__);
+	    fflush(stderr);
 	    xmlNodePtr n = printWPSHeader(doc,m,"DescribeProcess",
 					  root_nodes[vid][1],(version!=NULL?version->value:"1.0.0"),1);
@@ -1519,5 +1534,5 @@
 			      free (REQUEST);
 			      closedir (dirp);
-			      xmlFreeDoc (doc);
+			      //xmlFreeDoc (doc);
 			      xmlCleanupParser ();
 			      zooXmlCleanupNs ();
@@ -1550,8 +1565,11 @@
 			  addToMap (request_inputs, "metapath", tmpMap->value);
 			map *tmpMapI = getMapFromMaps (m, "lenv", "Identifier");
+			/**
+			 * No support for dot in service name stored in metadb!?
 #ifdef META_DB
-			service* s2=extractServiceFromDb(m,tmpMapI->name,0);
+			service* s2=extractServiceFromDb(m,tmpMapI->value,0);
 			if(s2==NULL){
 #endif
+			*/
 			  s1 = (service *) malloc (SERVICE_SIZE);
 			  t = readServiceFile (m, buff1, &s1, tmpMapI->value);
@@ -1585,5 +1603,5 @@
 			      free (s1);
 			      closedir (dirp);
-			      xmlFreeDoc (doc);
+			      //xmlFreeDoc (doc);
 			      xmlCleanupParser ();
 			      zooXmlCleanupNs ();
@@ -1604,7 +1622,9 @@
 			  hasVal = 1;
 			  setMapInMaps (m, "lenv", "level", "0");
+			  /*
 #ifdef META_DB
 			}
 #endif
+			  */
 		      }
 		    else
@@ -1688,5 +1708,5 @@
 				      free (REQUEST);
 				      closedir (dirp);
-				      xmlFreeDoc (doc);
+				      //xmlFreeDoc (doc);
 				      xmlCleanupParser ();
 				      zooXmlCleanupNs ();
@@ -1736,5 +1756,5 @@
 			free (REQUEST);
 			closedir (dirp);
-			xmlFreeDoc (doc);
+			//xmlFreeDoc (doc);
 			xmlCleanupParser ();
 			zooXmlCleanupNs ();
@@ -1843,7 +1863,5 @@
   }
   s1 = NULL;
-  if(postRequest!=NULL)
-    setMapInMaps (m, "lenv", "xrequest", postRequest->value);
-  
+ 
   r_inputs = getMap (request_inputs, "Identifier");
   map* import = getMapFromMaps (m, IMPORTSERVICE, r_inputs->value); 
@@ -1880,8 +1898,9 @@
   fprintf(stderr,"CONNECTING METADB!\n");
   //FAILED CONNECTING DB
-  if(getMapFromMaps(m,"lenv","dbIssue")!=NULL){
+  if(getMapFromMaps(m,"lenv","dbIssue")!=NULL || metadb_id<0){
     fprintf(stderr,"ERROR CONNECTING METADB\n");
   }
-  s1=extractServiceFromDb(m,r_inputs->value,0);
+  if(metadb_id>=0)
+    s1=extractServiceFromDb(m,r_inputs->value,0);
   //close_sql(m,0);
   if(s1!=NULL){
@@ -2181,7 +2200,9 @@
     {
       int hasValidCookie = -1;
-      char *tcook = zStrdup (cgiCookie);
+      char *tcook = originalCookie = zStrdup (cgiCookie);
+      //fprintf(stderr,">>>>> %s %d %s\n",__FILE__,__LINE__,tcook );
       char *tmp = NULL;
       map *testing = getMapFromMaps (m, "main", "cookiePrefix");
+      parseCookie(&m,originalCookie);
       if (testing == NULL)
         {
@@ -2197,5 +2218,5 @@
         {
           char *token, *saveptr;
-          token = strtok_r (cgiCookie, ";", &saveptr);
+          token = strtok_r (tcook, ";", &saveptr);
           while (token != NULL)
             {
@@ -2244,7 +2265,12 @@
           if (istat == 0 && file_status.st_size > 0)
             {
+	      int saved_stdout = dup (fileno (stdout));
+	      dup2 (fileno (stderr), fileno (stdout));
               conf_read (session_file_path, tmpSess);
               addMapsToMaps (&m, tmpSess);
               freeMaps (&tmpSess);
+	      fflush(stdout);
+	      dup2 (saved_stdout, fileno (stdout));
+	      close(saved_stdout);
             }
 	  free (tmpSess);
@@ -2273,6 +2299,6 @@
       char* tmpName=zStrdup(s);
       char* tmpValue=strstr(s,"=")+1;
-      char* tmpName1=(char*)malloc((1+(len-strlen(tmpValue)))*sizeof(char));
-      snprintf(tmpName1,(len-strlen(tmpValue))+1,"%s",tmpName);
+      char* tmpName1=(char*)malloc((1+(len-(strlen(tmpValue)+1)))*sizeof(char));
+      snprintf(tmpName1,(len-strlen(tmpValue)),"%s",tmpName);
       if(_tmpMaps->content == NULL)
 	_tmpMaps->content = createMap (tmpName1,tmpValue);
@@ -2285,15 +2311,12 @@
   }
   if(_tmpMaps->content!=NULL && getMap(_tmpMaps->content,"HTTP_COOKIE")!=NULL){
-    /*map* tmpMap1=getMap(_tmpMaps->content,"HTTP_COOKIE");
-    free(tmpMap1->value);
-    tmpMap1->value=zStrdup(cgiCookie);*/
-    fprintf(stderr,"[%s]\n",cgiCookie);
     addToMap(_tmpMaps->content,"HTTP_COOKIE1",&cgiCookie[0]);
-    dumpMap(_tmpMaps->content);
   }
   addMapsToMaps (&m, _tmpMaps);
   freeMaps (&_tmpMaps);
   free (_tmpMaps);
-
+  if(postRequest!=NULL)
+    setMapInMaps (m, "renv", "xrequest", postRequest->value);
+  //dumpMaps(m);
 #ifdef WIN32
   char *cgiSidL = NULL;
@@ -2334,5 +2357,4 @@
 				  "ZooWPSClient\0",
 				  INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);*/
-
       if(validateRequest(&m,s1,request_inputs, &request_input_real_format,&request_output_real_format,&hInternet)<0){
 	freeService (&s1);
@@ -2350,16 +2372,15 @@
 	return -1;
       }
-      fprintf(stderr,"*************************\n\n");
-      //fprintf(stderr,"%s \n",json_object_to_json_string_ext(mapsToJson(request_input_real_format),JSON_C_TO_STRING_PLAIN));
-      fprintf(stderr,"*************************\n\n");
       loadServiceAndRun (&m, s1, request_inputs, &request_input_real_format,
                          &request_output_real_format, &eres);
-#ifdef RELY_ON_DB
+
 #ifdef META_DB
-      close_sql(m,1);
+      close_sql(m,0);      
+#endif      
+
+      /*#ifdef RELY_ON_DB
+      //close_sql(m,1);
       //end_sql();
-#endif
-      close_sql(m,0);
-#endif      
+      #endif*/
     }
   else
@@ -2387,4 +2408,5 @@
         }
 #endif
+      //InternetCloseHandle (&hInternet);
       if (pid > 0)
         {
@@ -2411,4 +2433,15 @@
           setMapInMaps (m, "lenv", "async","true");
 	  map* r_inputs1 = createMap("ServiceName", s1->name);
+
+	  /*hInternet = InternetOpen (
+#ifndef WIN32
+				    (LPCTSTR)
+#endif
+				    "ZooWPSClient\0",
+				    INTERNET_OPEN_TYPE_PRECONFIG, NULL, NULL, 0);
+#ifndef WIN32
+	  if (!CHECK_INET_HANDLE (hInternet))
+	    fprintf (stderr, "WARNING : hInternet handle failed to initialize");
+	    #endif*/
 
 	  // Create the filename for the result file (.res)
@@ -2525,13 +2558,34 @@
 	  invokeCallback(m,request_input_real_format,NULL,1,0);
 	  fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
+	  dumpMaps(request_output_real_format);
 	  if(validateRequest(&m,s1,request_inputs, &request_input_real_format,&request_output_real_format,&hInternet)<0){
 	    freeService (&s1);
 	    free (s1);
+	    fflush (stdout);
+	    fflush (stderr);
 	    fclose (f0);
 	    fclose (f1);
 	    if(dumpBackFinalFile(m,fbkp,fbkp1)<0)
 	      return -1;
+	    //dumpBackFinalFile(m,fbkp,fbkp1);
+#ifndef RELY_ON_DB
+	    dumpMapsToFile(bmap,fbkpres,1);
+	    removeShmLock (m, 1);
+#else
+	    recordResponse(m,fbkp1);
+	    fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
+	    invokeCallback(m,NULL,NULL,7,0);
+	    fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
+#endif
 	    unlink (fbkpid);
 	    unhandleStatus (m);
+#ifdef RELY_ON_DB
+#ifdef META_DB
+	    cleanupCallbackThreads();
+	    close_sql(m,1);
+	    //end_sql();
+#endif
+	    close_sql(m,0);
+#endif
 	    freeMaps (&m);
 	    free (m);
@@ -2544,15 +2598,22 @@
 	    freeMaps (&tmpmaps);
 	    free (tmpmaps);
-	    fflush (stdout);
-	    fflush (stderr);
 	    return -1;
 	  }
+	  dumpMaps(request_output_real_format);
 	  fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
 	  invokeCallback(m,request_input_real_format,NULL,1,1);
 	  fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
-	  setMapInMaps(m,"lenv","ds_nb","1");
-          loadServiceAndRun (&m, s1, request_inputs,
-                             &request_input_real_format,
-                             &request_output_real_format, &eres);
+          if(getMapFromMaps(m,"lenv","mapError")!=NULL){
+		setMapInMaps(m,"lenv","message",_("Issue with geographic data"));
+	  	invokeCallback(m,NULL,NULL,7,0);
+		eres=-1;//SERVICE_FAILED;
+	  }else{
+	    setMapInMaps(m,"lenv","ds_nb","0");
+	    close_sql(m,0);
+	    loadServiceAndRun (&m, s1, request_inputs,
+			       &request_input_real_format,
+			       &request_output_real_format, &eres);
+	    setMapInMaps(m,"lenv","ds_nb","2");
+	  }
         }
       else
@@ -2573,4 +2634,6 @@
   fprintf (stderr, "RUN IN BACKGROUND MODE %s %d \n",__FILE__,__LINE__);
 #endif
+fflush(stdout);
+rewind(stdout);
   if (eres != -1)
     outputResponse (s1, request_input_real_format,
@@ -2595,9 +2658,9 @@
   if (((int) getpid ()) != cpid || cgiSid != NULL)
     {
-      fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
+      if (eres == SERVICE_SUCCEEDED)
+	invokeCallback(m,NULL,request_output_real_format,5,1);
+
       fflush(stderr);
-      invokeCallback(m,NULL,request_output_real_format,5,1);
-      fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
-      fflush(stderr);
+      fflush(stdout);
 
       fclose (stdout);
@@ -2619,5 +2682,5 @@
 	setMapInMaps(m,"lenv","fstate",wpsStatus[0]);
 	break;
-      }      
+      }
 #ifndef RELY_ON_DB
       dumpMapsToFile(bmap,fbkpres,1);
@@ -2625,7 +2688,6 @@
 #else
       recordResponse(m,fbkp1);
-      fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
-      invokeCallback(m,NULL,request_output_real_format,6,0);
-      fprintf(stderr,"************************* %s %d \n\n",__FILE__,__LINE__);
+      if (eres == SERVICE_SUCCEEDED)
+	invokeCallback(m,NULL,request_output_real_format,6,0);
 #endif
       freeMaps(&bmap);
@@ -2637,12 +2699,10 @@
       cleanupCallbackThreads();
       close_sql(m,1);
-      //end_sql();
 #endif
       close_sql(m,0);
-#endif
-      unlink (flog);
+      end_sql();
+#endif
       free(fbkpid);
       free(fbkpres); 
-      free (flog);           
       free (fbkp1);
       // free (tmps1); // tmps1 is stack memory and should not be freed
@@ -2653,4 +2713,6 @@
       fflush(stderr);
       fclose (stderr);
+      unlink (flog);
+      free (flog);
     }
   else{
Index: /branches/prototype-v0/zoo-project/zoo-services/gdal/dem/cgi-env/Gdal_Dem.zcfg
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-services/gdal/dem/cgi-env/Gdal_Dem.zcfg	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-services/gdal/dem/cgi-env/Gdal_Dem.zcfg	(revision 854)
@@ -44,4 +44,13 @@
     <Default />
    </LiteralData>
+  [co]
+   Title = Creation Option
+   Abstract = string representing options (NAME=VALUE)
+   minOccurs = 0
+   maxOccurs = 1
+   <LiteralData>
+    DataType = string
+    <Default />
+   </LiteralData>
  </DataInputs>
  <DataOutputs>
Index: /branches/prototype-v0/zoo-project/zoo-services/gdal/dem/service.c
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-services/gdal/dem/service.c	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-services/gdal/dem/service.c	(revision 854)
@@ -2486,4 +2486,19 @@
       setMapInMaps(outputs,"Result","value",tmpMap->value);
     }
+    
+    tmpMap=getMapFromMaps(inputs,"co","value");
+    if(tmpMap!=NULL){
+      papszCreateOptions = CSLAddString( papszCreateOptions, tmpMap->value );  
+      map* tmpMap1;
+      maps* tmpMaps=getMaps(inputs,"co");
+      if((tmpMap1=getMapFromMaps(inputs,"co","length"))!=NULL){
+        int i=1;
+        int length=atoi(tmpMap1->value);
+        for(;i<length;i++){
+          tmpMap=getMapArray(tmpMaps->content,"value",i);
+          papszCreateOptions = CSLAddString( papszCreateOptions, tmpMap->value );
+        }
+      } 
+    }    
 
     tmpMap=NULL;
Index: /branches/prototype-v0/zoo-project/zoo-services/utils/hpc/Makefile
===================================================================
--- /branches/prototype-v0/zoo-project/zoo-services/utils/hpc/Makefile	(revision 853)
+++ /branches/prototype-v0/zoo-project/zoo-services/utils/hpc/Makefile	(revision 854)
@@ -4,5 +4,5 @@
 
 cgi-env/wps_hpc.zo: service.c
-	g++ ${CFLAGS} -shared -fpic -o cgi-env/wps_hpc.zo ./service.c ${GDAL_LIBS} ${XML2LDFLAGS} ${MACOS_LD_FLAGS} ${ZOO_LDFLAGS} ${MACOS_LD_NET_FLAGS} ${XSLT_LDFLAGS} ${FCGI_LDFLAGS} -L${ZRPATH}/zoo-kernel/ -lzoo_service ${ZRPATH}/zoo-kernel/sshapi.o ${HPCLDFLAGS}
+	g++ ${CFLAGS} -shared -fpic -o cgi-env/wps_hpc.zo service.c service2.c ${GDAL_LIBS} ${XML2LDFLAGS} ${MACOS_LD_FLAGS} ${ZOO_LDFLAGS} ${MACOS_LD_NET_FLAGS} ${XSLT_LDFLAGS} ${FCGI_LDFLAGS} -L${ZRPATH}/zoo-kernel/ -lzoo_service ${ZRPATH}/zoo-kernel/sshapi.o ${HPCLDFLAGS}
 
 install:
